<?php

function passwd($login,$pass)
{
  return md5(md5($pass).$login);
}

function check_session()
{
  if (!empty($_POST['login']) && !empty($_POST['passwd'])) {
    require_once('lib/login.php');
    if (check_passwd()) {
      header('Location: ./');
      exit();
    }
  }

  if (empty($_SESSION['sys']['login']) && empty($_GET['login'])) {
    header('Location: ./?login=true');
    exit();
  }
}

function sanitise_filename($file)
{
  return str_replace('./','x',$file);
}

function load_mask($name)
{
  global $mask;

  $name = sanitise_filename($name);
  $file = $_SESSION['sys']['basedir'] . 'masks/' . $name . '.php';

  if (!file_exists($file))
    return false;

  include_once($file);

  return true;
}

function connect_db()
{
  $dsn = sprintf('host=%s dbname=%s user=%s password=%s',DBHOST,DBNAME,DBUSER,DBPASS);
  pg_connect($dsn);
}

function query_db($sql)
{
  $sth = pg_query($sql);

  if ($sth === false) return false;

  $result = array();
  while ($row = pg_fetch_assoc($sth))
    $result[] = $row;

  return $result;
}

function load_js($jsfiles, $jscode)
{
  $ret = '';
  foreach ($jsfiles as $file)
    $ret .= sprintf('<script type="text/javascript" src="%s"></script>'."\n", $file);

  if (!empty($jscode))
    $ret .= sprintf('<script type="text/javascript">'."\n%s\n</script>\n", implode("\n",$jscode));

  return $ret;
}

function process()
{
  if (!empty($_GET['login'])) {
    require_once('lib/login.php');
    return mask_login();
  }

  if (!empty($_GET['mask'])) {
    require_once('lib/mask.php');
    return mask($_GET['mask']);
  }

  $masks = array('sys_user','sys_group','sys_mask',
		 'anbaugeraete','arbeitsarten','personal','materialien','gebiet','geraete',
		 'kostenstellen','materialverbrauch','einsatz');
  $ret = '';
  foreach ($masks as $m)
    $ret .= sprintf('<a href="index.php?mask=%s">%s</a><br>', $m, $m);
  
  return $ret;
}

function debug_log($text)
{
  global $debug_info;

  $debug_info .= '<br>' . $text;
}

function debug_info()
{
  global $jsfiles;
  global $debug_info;

  if (DEBUG !== true) return '';

  $jsfiles[] = 'lib/debug_joey.js';

  $html = '<div style="background: #DDD; margin: 5px; padding-left: 4px; border: 1px solid #AAA;clear:both;">';
  $html .= "\n<pre>\n\$_SESSION = " . var_export($_SESSION,true) . "\n";
  $html .= "\n\$_COOKIE = " . var_export($_COOKIE,true) . "\n</pre>\n";
  $html .= $debug_info;
  $html .= '</div>';
  return $html;
}

?>
